//+------------------------------------------------------------------+
//|                               Forex Generator version 4.4        |
//|                                 Copyright (C) 2011, Etasoft Inc. |
//|                                    http://www.forexgenerator.com |
//+------------------------------------------------------------------+
// Keywords: indicator developer, Forex indicator builder, create forex indicator, MT4


#property copyright "Your copyright"
#property link "Link to your website"
#property indicator_separate_window
#property indicator_buffers 1

#property indicator_color1 Blue
#property indicator_width1 2


//extern int numDays = 5;
extern int numBars = 30;
extern int avgPeriod = 10;  // how many bars back to average the rolling separation volume

double Buffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    SetIndexBuffer(0, Buffer1);
    IndicatorShortName("Active Boundaries");
    return(0);
}
int deinit()
{
    return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _totPrePrice 0
#define _totVol      1

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
       
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      work[r][_totPrePrice] = work[r-1][_totPrePrice];
      work[r][_totVol]      = work[r-1][_totVol];
       
         double prePrice               = Close[i] * Volume[i];
                work[r][_totPrePrice] += prePrice;
                prePrice               = Close[i + numBars] * Volume[i + numBars];
                work[r][_totPrePrice] -= prePrice;
                work[r][_totVol]      += Volume[i] - Volume[i + numBars]; 
	    
         double avgPrice  = work[r][_totPrePrice] / work[r][_totVol];
         double avgProfit = (Close[i] - avgPrice) / avgPrice;
         double AB        = avgProfit * 100.0;
         Buffer1[i] = AB;
    }
    return(0);
}



